from . import (
    abstract,
    constitution,
    elem,
    math,
    opt,
    preset,
    problem,
    region,
    types,
    utils,
)
from ._version import __version__, __version_tuple__, version, version_tuple
from .abstract import (
    AbstractPhysicsProblem,
    InversePhysicsProblem,
    LinearOperator,
    as_linear_operator,
)
from .math import (
    diagonal,
    hess_as_operator,
    hess_diag,
    hvp,
    hvp_fun,
    jac_as_operator,
    jvp_fun,
    polar_rv,
    svd_rv,
)
from .opt import (
    LinearResult,
    MinimizeAlgorithm,
    MinimizeGradientDescent,
    MinimizePNCG,
    MinimizeResult,
    MinimizeScipy,
    cgls,
    minimize,
)
from .problem import Corotated, Fixed, Gravity, Koiter, Sum
from .region import Region, RegionTetra
from .types import Unraveler
from .utils import (
    RichResult,
    as_jax,
    clone,
    jit,
    merge,
    register_dataclass,
    rosen,
    tetwild,
)

__all__ = [
    "AbstractPhysicsProblem",
    "Corotated",
    "Fixed",
    "Gravity",
    "InversePhysicsProblem",
    "Koiter",
    "LinearOperator",
    "LinearResult",
    "MinimizeAlgorithm",
    "MinimizeGradientDescent",
    "MinimizePNCG",
    "MinimizeResult",
    "MinimizeScipy",
    "Region",
    "RegionTetra",
    "RichResult",
    "Sum",
    "Unraveler",
    "__version__",
    "__version_tuple__",
    "abstract",
    "as_jax",
    "as_linear_operator",
    "cgls",
    "clone",
    "constitution",
    "diagonal",
    "elem",
    "hess_as_operator",
    "hess_diag",
    "hvp",
    "hvp_fun",
    "jac_as_operator",
    "jit",
    "jvp_fun",
    "math",
    "merge",
    "minimize",
    "opt",
    "polar_rv",
    "preset",
    "problem",
    "region",
    "register_dataclass",
    "rosen",
    "svd_rv",
    "tetwild",
    "types",
    "utils",
    "version",
    "version_tuple",
]
